SystemOrganization addCategory: #'TP2-Parte3'!

Object subclass: #AplicarFuncionYDevolver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

Object subclass: #EjecutarTodasEnOrden
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 14:43'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 16:53'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 15:04'!
ejecutarTemporalmente: unMetodo dentroDe: unaClase por: implementador 

	unaClase methodDict at: #auxiliar put: (implementador >> unMetodo).
	! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 15:05'!
ejecutarTemporalmente: unMetodo dentroDe: unaClase por: implementador desde: unObjeto

	unaClase methodDict at: #auxiliar put: (implementador >> unMetodo).
	! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 15:05'!
ejecutarTemporalmente: unMetodo dentroDe: unaClase por: implementador desde: unObjeto conArgumentos: argumentos

	unaClase methodDict at: #auxiliar put: (implementador >> unMetodo).
	
	! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:47'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:17'!
preparar: unaClase paraResolver: unMetodo
	
	| compiledMethodsConflictivos |
	
	compiledMethodsConflictivos := Set new.
	
	compiledMethodsConflictivos add: (unaClase >> unMetodo ).
	
	compiledMethodsConflictivos addAll: (
		( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ) 
			collect: [ :trait | trait >> unMetodo ] ).	
	
	^compiledMethodsConflictivos! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 17:26'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal conflictivos withsArmados |
	
	codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
	withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

	unaClase compile:
	'original',codigoOriginal.
	
	unaClase compile:
	( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
		| conflictivos retorno argumentos withsArmados|
		
		argumentos := (EjecutarTodasEnOrden new) argumentosDe: ( (self class >> #original',unMetodo,' ) sourceCode ).
		
		conflictivos := ( (EjecutarTodasEnOrden new) obtenerTraitsConflictivosEn: self class para: #',unMetodo,' ). 
		
		retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
		retorno := conflictivos inject: retorno into: [ :resultado :implementador | (self class) methodDict at: #auxiliar put: (implementador >> #',unMetodo,') . 
			     																	    self perform: #auxiliar resultado ].
		(self class) methodDict at: #auxiliar put: nil.
		
		^retorno.
	'.
	! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:11'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

Object subclass: #LlamarConCondicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

Object subclass: #MockEstrategia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!MockEstrategia methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/1/2013 20:38'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase
	^unMetodo literals at: 2.! !

Object subclass: #Refactor3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 12:38'!
agregarTrait: unTrait a: unaClase con: unaEstrategia
	
	|metodosConflictivos|
	
	unaClase addToComposition: unTrait.
	
	metodosConflictivos := unTrait selectors select: [ :selector | self esConflitivo: selector en: unaClase ].
	
	metodosConflictivos do: [ :selector | unaEstrategia resolverConflictoPara: selector entre: unTrait  y: unaClase ].! !

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/2/2013 00:19'!
esConflitivo: unSelector en: unaClase
	|traits|
	
	traits := unaClase traits.
	
	^ (unaClase selectors includes: unSelector) | ( traits notEmpty and: [ traits anySatisfy: [ :unTrait | self esConflitivo: unSelector en: unTrait ] ] ). 
	
	"Mejorar TODO"! !

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:52'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !
